/**
 * This class is a list of FileReference entities. RWebServices 'knows'
 * about the collection, but not the individual FileReference elements.
 */
package org.bioconductor.packages.rservices;

import java.io.Serializable;
import java.util.ArrayList;

/**
 * @author mtmorgan
 * 
 */
public class FileReferences implements Serializable {

	private static final long serialVersionUID = 1L;

	protected ArrayList<FileReference> fileReferences = null;

	/**
	 * 
	 */
	public FileReferences() {
		this.fileReferences = new ArrayList<FileReference>();
	}

	/**
	 * @param fileReferences
	 */
	public FileReferences(ArrayList<FileReference> fileReferences) {
		this.fileReferences = fileReferences;
	}

    /**
	 * @param fileReferences
	 */
	public FileReferences(FileReference[] fileReferences) {
		this.fileReferences = new ArrayList<FileReference>(fileReferences.length);
		for (FileReference fref : fileReferences) {
			this.fileReferences.add(fref);
		}
	}

	/**
	 * @param size
	 */
	public FileReferences(int size) {
		this.fileReferences = new ArrayList<FileReference>(size);
	}

	/**
	 * @return the fileReferences size
	 * @see java.util.ArrayList#size()
	 */
	public int size() {
		return fileReferences.size();
	}

	/**
	 * @return the fileReferences
	 */
	public ArrayList<FileReference> getFileReferences() {
		return fileReferences;
	}

	/**
	 * @param fileReferences
	 *            the fileReferences to set
	 */
	public void setFileReferences(ArrayList<FileReference> fileReferences) {
		this.fileReferences = fileReferences;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result
				+ ((fileReferences == null) ? 0 : fileReferences.hashCode());
		return result;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final FileReferences other = (FileReferences) obj;
		if (fileReferences == null) {
			if (other.fileReferences != null)
				return false;
		} else if (!fileReferences.equals(other.fileReferences))
			return false;
		return true;
	}

}
