package org.bioconductor.packages.rservices;

import java.io.*;

public class TestDataCreater {

	private RServicesEnv e;

	public TestDataCreater(RServicesEnv renv) {
		e = renv;
	}

	public void dataRDataToJavaData(String rDataSet, String dataDir)
			throws Exception {
		String javaFileName = rDataSet + "_java.Data."
				+ (new Long(System.currentTimeMillis())).toString();
		String javaDataFile = (new File(dataDir, javaFileName)).getPath();
		System.out.println("load R data set " + rDataSet + " and save to "
				+ javaDataFile);
		e.setDataLoaderEnv();
		try {
			Object jData = e.dataRData(rDataSet);
			saveJavaData(javaDataFile, jData);
		} finally {
			e.rmDataLoaderEnv();
		}
	}

	public void loadRDataToJavaData(String dataDirName) throws Exception {
		File dataDir = new File(dataDirName);
		if (!dataDir.isDirectory()) {
			throw new Exception("Can't find directory " + dataDirName);
		}
		File[] rDataFiles = dataDir.listFiles();
		e.setDataLoaderEnv();
		try {
			for (File element : rDataFiles) {
				String rDataFileFullName = element.getPath();
				String javaDataFile = rDataFileFullName + "_java.Data."
						+ (new Long(System.currentTimeMillis())).toString();
				System.out.println("load R data file " + rDataFileFullName
						+ " and save to " + javaDataFile);
				Object jData = e.loadRData(rDataFileFullName);
				saveJavaData(javaDataFile, jData);
			}
		} finally {
			e.rmDataLoaderEnv();
		}
	}

	private void saveJavaData(String javaDataFile, Object javaData)
			throws Exception {
		FileOutputStream fout = null;
		ObjectOutputStream oout = null;
		try {
			fout = new FileOutputStream(javaDataFile);
			oout = new ObjectOutputStream(fout);
			oout.writeObject(javaData);
		} finally {
			oout.close();
			fout.close();
		}
	}

}
