testFileReferences <- function() {
    ## default constructors
    obj <- FileReferences()
    checkTrue(validObject(obj))
    checkIdentical(0L, length(obj))
    checkTrue(validObject(FileReferences("fdfs")))
    ## constructors
    obj <- FileReferences("/foo/bar/baz")
    checkTrue(validObject(obj))
    checkIdentical("/foo/bar/baz",  urls(obj))
    checkIdentical("baz",  localNames(obj))
    checkIdentical("", types(obj))
    checkIdentical(1L, length(obj))
    ## urls / localNames length mismatch
    checkException(FileReferences("/foo/bar", localNames=c("x", "y")),
                   silent=TRUE)
    checkException(FileReferences("/foo/bar", types=NA_character_),
                   silent=TRUE)
}

testRetrieveReferences <- function() {
    obj <- FileReferences(c("http://bioconductor.org/biocLite.R",
                            "http://bioconductor.org/biocLite.R"),
                          type=c("foo", "bar"))
    res <- retrieve(obj)
    checkIdentical(localNames(obj), localNames(res))
    checkIdentical(types(obj), types(res))
}
