package org.bioconductor.packages.rservices;

/*
 These test the converters between R and Java.
 Specifically, methods below pass simple data
 from Java to R and get the results back. This
 round-trip should test many of the converters.
*/

import java.util.*;
import java.lang.reflect.Array;
import org.omegahat.R.Java.ROmegahatInterpreter;
import org.omegahat.R.Java.REvaluator;
import org.bioconductor.packages.rservices.*;
import junit.framework.JUnit4TestAdapter;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.Ignore;
import static org.junit.Assert.*;
import testdata.*;

public class RClassTest extends org.bioconductor.packages.rservices.TypeTestUtil {
    /**                                                                                          
     * Used for backward compatibility (IDEs, Ant and JUnit 3.x text runner)
     */
    public static junit.framework.Test suite() {
        return new JUnit4TestAdapter(RClassTest.class);
    }

    /**
     * Sets up the test fixture; Called before all the tests; Called only once.
     */
    @BeforeClass
    public static void loadRWebServicesConverter() throws Exception {
        e.voidEval("regAddonCvt()");
    }
    
    @Test
    public void testClassUnion() throws Exception {
      String rscriptName=System.getProperty("ClassUnionScript");
      e.voidEval("source(\""+rscriptName+"\")");

      MyWrapper inputVal=new MyWrapper();
      MyUnionFactory unionFactory=MyUnionFactory.getMyUnionFactory(MyUnionFactory.RCHAR);
      RChar charVal=new RChar(new String[]{"v1", "v2"});
      unionFactory.setData(charVal);
      inputVal.setData(unionFactory);
      assertEquals(inputVal, reflectObj(inputVal));
    }

    @Ignore("coming soon...")
    @Test
    public void testS4Class() throws Exception {
    }
}

