\name{FileReferences}
\alias{FileReferences}
\alias{urls}
\alias{localNames}
\alias{types}
\alias{length,FileReferences-method}

\title{FileReferences constructor and accessors}

\description{
  Functions for creating and manipulating FileRefences-class objects.
}

\usage{
FileReferences(urls = character(), localNames = basename(urls),
               types = character(length(urls)), ...)
urls(object, ...)
localNames(object, ...)
types(object, ...)
\S4method{length}{FileReferences}(x)
}

\arguments{

  \item{urls}{A character vector of urls of the files to be
    referenced. The urls are the actual locations of the files.}

  \item{localNames}{A (optional) character vector of local names of the
    files to be references. Local names are the names used to refer to
    the files internally, e.g., by functions wanting to use file names
    as a label for data frame rows. The length of the local names
    argument must match that of the urls; the default is to take the
    file name portion of the url as the local name.}

  \item{types}{A (optional) character vector of length equal to that of
    the urls, containing the type each file represents. Type might
    normally come from a controlled vocabulary; the default is a length
    zero character string, reprsenting an unspecified type.}

  \item{object}{An object of class \code{FileReferences}, form which
    urls, local names, or types are to be extracted.}

  \item{x}{An object of class \code{FileReferences}, form which
    the length (number of file references) is to be determined.}

  \item{\dots}{Additional arguments, passed to the class initializaation
    method or (currently) ignored by the accessors.}

}

\value{

  \item{FileReferences}{Object of class
    \code{\linkS4class{FileReferences}}.}

  \item{urls, localNames, types}{character vector of urls, local names,
    or file types.}

  \item{length}{integer scalar of the number of references in the
    object.}

}

\author{Martin Morgan \url{mtmorgan@fhcrc.org}}

\seealso{\code{\linkS4class{FileReferences}-class}}

\examples{
obj <- FileReferences(c("/foo/bar", "/foo/baz"), type=rep("CEL", 2))
localNames(obj)
length(obj)
}

\keyword{manip}
