\name{generateDataTest}
\alias{generateDataTest}
\title{Create a Java program to test R - Java data type mapping}
\description{
  The \code{generateDataTest} function is used to validate the results
  of function \code{\link{generateDataMap}}. Given the name of a R data
  type, and the \code{lookup} environment updated by
  \code{generateDataMap}, function \code{generateDataTest} creates a test
  program in Java. The test program creates a java companion of the R data
  type, converts it to the R data type, and converts it back to Java. This
  round-trip can test both the Java bean and the convert functions.
} 
\usage{
generateDataTest(mainServ, mainPkg, lookup, addonType, verbose)
}
\arguments{
  \item{mainServ}{Name of web service; used to generate class name and
	properties files.}
  \item{mainPkg}{Package name, used in Java package hierarchy and
	usually the same as the R package name where the data object is
	defined.}
  \item{lookup}{environment containing mapping between R and Java types;
	see \code{\link{generateDataMap}}}
  \item{addonType}{character. Additional types required for creating the
	data test,e.g., to test conversion of an R \code{list} containing
	particular S4 classes requires that the particular classes be named
	as \code{addonType}.}
  \item{verbose}{logical. Report progress to console?}
}
\value{
  returns NULL.
}
\author{Nianhua Li}
\seealso{
\code{\link{generateDataMap}}
}
\examples{
  ## see '?generateDataMap' for an example of generating java test program 
}
\keyword{interface}
